
import sys
sys.path.append('../')

import numpy as np

from Poisson_problem import Poisson
from Poisson_problem_h import Poisson_h
from Poisson_problem_hd import Poisson_hd


K = [1, 1, 1, 1, 1, 1, 1, 1, 1,  1 ,  2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3]
N = [2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 2, 3, 4, 5, 6, 7, 8, 9, 2, 3, 4, 5, 6, 7]
c0 = [0. for _ in range(len(K))]
c1 = [0.125 for _ in range(len(K))]
c2 = [0.25 for _ in range(len(K))]
KKp = K * 3
NNp = N * 3
CCp = c0 + c1 + c2



K = [4, 6, 8, 10, 12, 14, 16, 18, 4, 6, 8, 10, 12, 14, 4, 6, 8, 10]
N = [1, 1, 1, 1 , 1 , 1 , 1 , 1 , 2, 2, 2, 2 , 2 , 2 , 3, 3, 3, 3 ]
c0= [0. for i in range(len(K))]
c1 = [0.125 for _ in range(len(K))]
c2 = [0.25 for _ in range(len(K))]
KKh = K * 3
NNh = N * 3
CCh = c0 + c1 + c2



# # MSEM
#
# pc_results_array = None
# for K, N, c in zip(KKp, NNp, CCp):
#     print('\nK=', K, 'N=', N, 'c=', c)
#     results = Poisson(K, N, c)
#     results = np.array([K, N, c] + list(results))
#     if pc_results_array is None:
#         pc_results_array = results
#     else:
#         pc_results_array = np.vstack((pc_results_array, results))
#
#     # noinspection PyTypeChecker
#     np.savetxt('MSEM_p_convergence.txt', pc_results_array,
#              header='K, N, c, u_L2, u_Hdiv, phi_L2, f_L2, div_L2, div_Linf')
#
#
# hc_results_array = None
# for K, N, c in zip(KKh, NNh, CCh):
#     print('\nK=', K, 'N=', N, 'c=', c)
#     results = Poisson(K, N, c)
#     results = np.array([K, N, c] + list(results))
#     if hc_results_array is None:
#         hc_results_array = results
#     else:
#         hc_results_array = np.vstack((hc_results_array, results))
#
#     # noinspection PyTypeChecker
#     np.savetxt('MSEM_h_convergence.txt', hc_results_array,
#             header='K, N, c, u_L2, u_Hdiv, phi_L2, f_L2, div_L2, div_Linf')
#
#
#
#
#
# # hMSEM
#
# pc_results_array = None
# for K, N, c in zip(KKp, NNp, CCp):
#     print('\nK=', K, 'N=', N, 'c=', c)
#     results = Poisson_h(K, N, c)
#     results = np.array([K, N, c] + list(results))
#     if pc_results_array is None:
#         pc_results_array = results
#     else:
#         pc_results_array = np.vstack((pc_results_array, results))
#
#     # noinspection PyTypeChecker
#     np.savetxt('hMSEM_p_convergence.txt', pc_results_array,
#              header='K, N, c, u_L2, u_Hdiv, phi_L2, f_L2, div_L2, div_Linf')
#
#
# hc_results_array = None
# for K, N, c in zip(KKh, NNh, CCh):
#     print('\nK=', K, 'N=', N, 'c=', c)
#     results = Poisson_h(K, N, c)
#     results = np.array([K, N, c] + list(results))
#     if hc_results_array is None:
#         hc_results_array = results
#     else:
#         hc_results_array = np.vstack((hc_results_array, results))
#
#     # noinspection PyTypeChecker
#     np.savetxt('hMSEM_h_convergence.txt', hc_results_array,
#             header='K, N, c, u_L2, u_Hdiv, phi_L2, f_L2, div_L2, div_Linf')



# hdMSEM

pc_results_array = None
for K, N, c in zip(KKp, NNp, CCp):
    print('\nK=', K, 'N=', N, 'c=', c)
    results = Poisson_hd(K, N, c)
    results = np.array([K, N, c] + list(results))
    if pc_results_array is None:
        pc_results_array = results
    else:
        pc_results_array = np.vstack((pc_results_array, results))

    # noinspection PyTypeChecker
    # np.savetxt('hdMSEM_p_convergence.txt', pc_results_array,
    #          header='K, N, c, u_L2, u_Hdiv, phi_L2, f_L2, div_L2, div_Linf, phi_dH, d_phi_u')

hc_results_array = None
for K, N, c in zip(KKh, NNh, CCh):
    print('\nK=', K, 'N=', N, 'c=', c)
    results = Poisson_hd(K, N, c)
    results = np.array([K, N, c] + list(results))
    if hc_results_array is None:
        hc_results_array = results
    else:
        hc_results_array = np.vstack((hc_results_array, results))

    # noinspection PyTypeChecker
    # np.savetxt('hdMSEM_h_convergence.txt', hc_results_array,
    #         header='K, N, c, u_L2, u_Hdiv, phi_L2, f_L2, div_L2, div_Linf, phi_dH, d_phi_u')